package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: TransactionType
// UnionValue: UpdateKey

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("UpdateKey")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UpdateKey implements TransactionBody {
	public final TransactionType type = TransactionType.UPDATE_KEY;
	private byte[] newKeyHash;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getNewKeyHash() {
	    return newKeyHash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setNewKeyHash(final byte[] value) {
	    this.newKeyHash = value;
	}

	public UpdateKey newKeyHash(final byte[] value) {
	    setNewKeyHash(value);
	    return this;
	}
	public UpdateKey newKeyHash(final String value) {
		try {
			setNewKeyHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.newKeyHash == null || this.newKeyHash.length == 0)) {
            marshaller.writeBytes(2, this.newKeyHash);
        }
        return marshaller.array();
    }
}
